routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

//Route::get('/', function () {
//    return view('layout');
//});
//Route::resource('agences', 'AgenceController');
//Route::resource('regionals', 'RegionalController');
//Route::resource('centrals', 'CentralController');
//Route::resource('structures/{type_id}', 'StructureController');
Auth::routes();
Route::get('/', 'HomeController@index')->name('home');
Route::middleware(['web'])->group(function () {



    Route::get('historiques', 'HistoryController@index');
    Route::resource('user', 'UserController');
    Route::put('user/{id}/edit', 'UserController@password')->name('user.password');
    Route::resource('document', 'DocumentController');
    Route::resource('nomenclature', 'NomenclatureController');
    Route::resource('calendrier', 'CalendrierController');
    Route::get('versement', 'VersementController@index')->name('versement.index');
    Route::post('versement', 'VersementController@decision')->name('versement.decision');
    Route::get('demande', 'DemandeController@index')->name('demande.index');
    Route::post('demande/{id}', 'DemandeController@decision')->name('demande.decision');

    Route::get('/ajax/structurestype/{type?}', 'UserController@StructuresType')->name('ajax.structurestype');
    Route::get('structures/{type_id}', 'StructureController@index')->name('structure.index');
    Route::get('structures/{type_id}/create', 'StructureController@create')->name('structure.create');
    Route::post('structures/{type_id}', 'StructureController@store')->name('structure.store');
    Route::get('structures/{type_id}/{structure}/edit', 'StructureController@edit')->name('structure.edit');
    Route::put('structures/{type_id}/{structure}', 'StructureController@update')->name('structure.update');
    Route::get('structures/{type_id}/{structure}', 'StructureController@show')->name('structure.show');
    Route::delete('structures/{type_id}/{structure}', 'StructureController@destroy')->name('structure.delete');

    Route::get('consultation', 'ConsultationController@index')->name('consultation.index');
    Route::post('consultation/create', 'ConsultationController@store')->name('consultation.store');
    Route::get('consultation/create', 'ConsultationController@create')->name('consultation.create');
    Route::post('consultation/{id}', 'ConsultationController@decision')->name('consultation.decision');


    Route::get('enlevement/demandes', 'EnlevementController@demandes')->name('enlevement.demandes');
    Route::put('enlevement/demandes/{enlevement}', 'EnlevementController@date')->name('enlevement.date');
    Route::get('enlevement/calendar', 'EnlevementController@calendar')->name('enlevement.calendar');
    Route::resource('enlevement', 'EnlevementController');


});

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use Notifiable,HasRoles;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'email', 'password',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function structure()
    {
        return $this->belongsTo('App\Structure');
    }
//    public function setPasswordAttribute($password)
//    {
//        if ( !empty($password) ) {
//            $this->attributes['password'] = bcrypt($password);
//        }
//    }
    public function versements()
    {
        return $this->hasMany('App\Versement');
    }
    public function consultations()
    {
        return $this->hasMany('App\Consultation');
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\History;
use App\Structure;
use App\Type;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;

class UserController extends Controller
{
    public function index()
    {
        $users=User::where('id','!=',1)->get();
        return view('users.index',compact('users'));
    }
    public function create()
    {
        $types=Type::all();
        return view('users.create',compact('types'));
    }
    public function store(Request $request)
    {
        $request->validate([
            'name' => 'required',
            'email' => 'required',
            'matricule' => 'required',
            'password' => 'required',
            'role' => 'required',
        ]);
        $user=new User();
        $user->name=$request->name;
        $user->email=$request->email;
        $user->password=bcrypt($request->password);
        $user->matricule=$request->matricule;
        if($request->structure)
        {
            $user->structure_id=$request->structure;
        }
        if($request->role==0)
            $user->assignRole('employée');
        else
            $user->assignRole('responsable');
//        $prearchive=Structure::find($request->structure);

        $user->save();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Création d\'un Utilisateur'
        ]);
        return redirect(route('user.index'))->with('message','l\'utilisateur '.$user->name.' a été crée avec succès ROLE:'.$user->getRoleNames()->first());
    }

    public function show($id)
    {
        if(Auth::user()->id==1)
        {
            $user=User::find($id);
            $role=$user->getRoleNames()->first();
            $types=Type::all();
            return view('users.show',compact('user','types','role'));
        }
       elseif (Auth::user()->id==$id)
       {
           $user=User::find($id);
           $role=$user->getRoleNames()->first();
           $types=Type::all();
           return view('users.show',compact('user','types','role'));
       }
        else
        {
            return redirect()->back()->with('error','vous n\'avez pas le droit ');
        }

    }
    public function edit($id)
    {
        $user=User::find($id);
        $types=Type::all();
        $role=$user->getRoleNames()->first();
        return view('users.edit',compact('user','types','role'));
    }

    public function update(Request $request,$id)
    {
//        dd($request->all());
        $request->validate([
            'name' => 'required',
            'email' => 'required',
            'matricule' => 'required',
            'role' => 'required',
        ]);
        $user=User::find($id);
        $user->name=$request->name;
        $user->email=$request->email;
        if($request->role==0)
            $user->assignRole('employée');
        else
            $user->assignRole('responsable');
        $user->matricule=$request->matricule;
        if($request->structure)
        {
            $user->structure_id=$request->structure;
        }

        $user->update();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Modification d\'un Utilisateur'
        ]);
        return redirect(route('user.index'))->with('message','l\'utilisateur '.$user->name.' a été modifiée avec succès ROLE:'.$user->getRoleNames()->first());
    }
    public function password(Request $request,$id){
        $user=User::find($id);
        if($request->password)
         $user->password=bcrypt($request->password);
        $user->update();
        return redirect(route('user.index'))->with('message','le mot de passe de l\'utilisateur '.$user->name.' a été modifiée avec succès ');
    }
    public function destroy($id)
    {
        $user=User::find($id);
        $name=$user->name;
        $user->delete();
        History::create([
            'structure_id'=>Auth::user()->structure->id,
            'user_id'=>Auth::id(),
            'action'=>'Suppression d\'un Utilisateur'
        ]);
        return redirect(route('user.index'))->with('message','l\'utilisateur '.$user->name.' a été supprimée avec succès ');
    }
    public function StructuresType($type)
    {
      $structures=Structure::where('type_id','=',$type)->get();
      return view('users.ajaxtype',compact('structures'));
    }
}

resources/views/users/ajaxtype.blade.php
<label class="col-sm-2 col-form-label">Structure</label>
<div class="col-sm-10">
    <select name="structure" class="js-example-theme-single2 form-control">
        <option disabled selected >Choisir la structure pour l'utilisateur</option>
        @foreach($structures as $structure)
            <option value="{{$structure->id}}">{{$structure->nom}}</option>
        @endforeach
    </select>
</div>

resources/views/users/create.blade.php
@extends('layout')
@section('css')
    <!-- Select 2 css -->
    <link rel="stylesheet" href="{{asset('bower_components/select2/css/select2.min.css')}}"/>
@endsection
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont icofont-user bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Utilisateurs</h4>
                        <span>Ajouter un<code style="text-transform: uppercase">Utilisateur</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Ajouter Un Nouveau Utilisateur </a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">

                    <div class="card-block">
                        <h4 class="sub-title">Formulaire de Création</h4>
                        <form method="post" action="{{route('user.store')}}">
                            @csrf
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nom</label>
                                <div class="col-sm-10">
                                    <input name="name" type="text" class="form-control" placeholder="Nom Utilisateur">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Email</label>
                                <div class="col-sm-10">
                                    <input name="email" type="email" class="form-control"  placeholder="Email Utilisateur">
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Password</label>
                                <div class="col-sm-10">
                                    <input name="password" type="password" class="form-control" placeholder="Mot de Passe">
                                </div>
                            </div>
{{--                            <div class="form-group row">--}}
{{--                                <label class="col-sm-2 col-form-label">Matricule</label>--}}
{{--                                <div class="col-sm-10">--}}
{{--                                    <input name="matricule" type="text" class="form-control" placeholder="Matricule Utilisateur">--}}
{{--                                </div>--}}
{{--                            </div>--}}
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Matricule</label>
                                <div class="input-group col-sm-10">
                                    <input name="matricule" placeholder="Matricule Utilisateur" type="text" class="form-control" rel="gp" data-size="6" data-character-set="a-z,A-Z,0-9">
                                    <span class="input-group-btn"><button type="button" class="btn btn-default getNewPass"><span class="fa fa-refresh"></span></button></span>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Role</label>
                                <div class="input-group col-sm-10">
                                    <select name="role" class="form-control">
                                            <option selected value="0">Employée</option>
                                            <option value="1">Responsable</option>
                                    </select>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Type Structure</label>
                                <div class="col-sm-10">
                                    <select id="options" name="type" class="js-example-theme-single form-control">
                                        <option disabled selected >Choisir la structure pour l'utilisateur</option>
                                        @foreach($types as $type)
                                            <option value="{{$type->id}}">{{$type->name}}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                            <div class="form-group row structures">

                            </div>

                            <div class="text-center">
                                <button type="submit" class="col-md-3 btn btn-out-dashed btn-success btn-square">Créer</button>
                            </div>
                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection
@section('scripts')
    <script type="text/javascript" src="{{asset('bower_components/select2/js/select2.full.min.js')}}"></script>
{{--    <script type="text/javascript" src="{{asset('assets/pages/advance-elements/select2-custom.js')}}"></script>--}}
    <script>
        // Generate a password string
        function randString(id){
            var dataSet = $(id).attr('data-character-set').split(',');
            var possible = '';
            if($.inArray('a-z', dataSet) >= 0){
                possible += 'abcdefghijklmnopqrstuvwxyz';
            }
            if($.inArray('A-Z', dataSet) >= 0){
                possible += 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
            }
            if($.inArray('0-9', dataSet) >= 0){
                possible += '0123456789';
            }
            if($.inArray('#', dataSet) >= 0){
                possible += '![]{}()%&*$#^<>~@|';
            }
            var text = '';
            for(var i=0; i < $(id).attr('data-size'); i++) {
                text += possible.charAt(Math.floor(Math.random() * possible.length));
            }
            return text;
        }

        // Create a new password on page load
        $('input[rel="gp"]').each(function(){
            $(this).val(randString($(this)));
        });

        // Create a new password
        $(".getNewPass").click(function(){
            var field = $(this).closest('div').find('input[rel="gp"]');
            field.val(randString(field));
        });

        // Auto Select Pass On Focus
        $('input[rel="gp"]').on("click", function () {
            $(this).select();
        });

        $(document).ready(function() {
            $('.js-example-theme-single').select2();
            $(document).on('change','#options',function () {
                $.ajax({
                    url: '{{route('ajax.structurestype')}}'+'/'+ $('#options').val(),
                    method: "GET",
                    success: function(response) {
                        // $('.select2-voitures').select2().destroy();
                        $(".structures").html(response);
                        $('.js-example-theme-single').select2();
                    }
                });
            });
        });
    </script>
@endsection

resources/views/users/index.blade.php
@extends('layout')
@section('nom')

@endsection
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont icofont-user bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Utilisateurs</h4>
                        <span>Liste des <code style="text-transform: uppercase">Utilisateurs</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Liste des Utilisateurs</a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- DOM/Jquery table start -->
                <div class="card">

                    <div class="card-block">
                        <a href="{{route('user.create')}}" type="button" id="addRow" class="btn btn-primary m-b-20 float-lg-right">+ Créer Un Nouvel Utilisateur </a>
                        <div class="table-responsive dt-responsive">
                            <table id="dom-jqry" class="table table-striped table-bordered nowrap">
                                <thead>
                                <tr>
                                    <th>nom</th>
                                    <th>matricule</th>
                                    <th>structure</th>
{{--                                    <th>role</th>--}}
{{--                                    <th>adresse</th>--}}
{{--                                    <th>Lieu Conservation Age 2</th>--}}
                                    <th>Actions</th>
                                </tr>
                                </thead>
                                <tbody>
                                @foreach($users as $user)
                                    <tr>
                                        <td>{{$user->name}}
                                            @if($user->hasrole('admin')) <span class="badge badge-success">admin</span>@endif
                                            @if($user->hasrole('responsable'))<span class="badge badge-info">responsable</span>@endif
                                        </td>
                                        <td>{{$user->matricule}}</td>
                                        <td>{{$user->structure->type->name}}|{{$user->structure->adresse}}</td>
{{--                                        <td>@if($user->hasrole('admin')) admin @elseif($user->hasrole('responsable')) responsable @elseif($user->hasrole('employée')) employée @endif     </td>--}}
{{--                                        <td>{{$user->age1}}</td>--}}
{{--                                        <td>{{$user->prearchive->nom}}</td>--}}
                                        <td>
                                            <a href="{{route('user.show',$user->id)}}" class="badge badge-md bg-success"><i class="fa fa-eye"></i></a>
                                            <a href="{{route('user.edit',$user->id)}}" class="badge badge-md bg-info"><i class="fa fa-pencil"></i></a>
                                            <a href="#" data-toggle="modal" data-target="#delete{{$user->id}}" class="badge badge-md bg-danger"><i class="fa fa-trash"></i></a>

                                        </td>
                                    </tr>
                                    <div class="modal fade" id="delete{{$user->id}}" tabindex="-1" role="dialog">
                                        <div class="modal-dialog" role="document">
                                            <div class="modal-content">
                                                <div class="modal-header">
                                                    <h4 class="modal-title">Confirmation de Suppression</h4>
                                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                                        <span aria-hidden="true">&times;</span>
                                                    </button>
                                                </div>
                                                <div class="modal-body">
                                                    <h5>Etes vous sûr de vouloir Supprimer cet Utilisateur "{{$user->name}}"?</h5>
                                                </div>
                                                <div class="modal-footer">
                                                    <form id="form" style="display: none;" method="post" action="{{route('user.destroy',$user->id)}}">
                                                        @csrf
                                                        @method('delete')
                                                    <button type="button" class="btn btn-info waves-effect " data-dismiss="modal">Non</button>
                                                    <button type="submit" class="btn btn-danger waves-effect waves-light ">Oui</button>

                                                    </form>

                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                @endforeach
                                </tbody>
                                <tfoot>
                                <tr>
                                    <th>nom</th>
                                    <th>matricule</th>
                                    <th>structure</th>
{{--                                    <th>role</th>--}}
                                    {{--                                    <th>adresse</th>--}}
{{--                                    <th>Lieu Conservation Age 2</th>--}}
                                    <th>Actions</th>
                                </tr>
                                </tfoot>
                            </table>
                        </div>
                    </div>
                </div>
                <!-- DOM/Jquery table end -->
            </div>
        </div>
    </div>
@endsection

resources/views/users/show.blade.php
@extends('layout')
@section('css')
    <!-- Select 2 css -->
    <link rel="stylesheet" href="{{asset('bower_components/select2/css/select2.min.css')}}"/>
@endsection
@section('content')
    <div class="page-header card">
        <div class="row align-items-end">
            <div class="col-lg-8">
                <div class="page-header-title">
                    <i class="icofont icofont-user bg-c-blue"></i>
                    <div class="d-inline">
                        <h4>Utilisateurs</h4>
                        <span>Afficher un<code style="text-transform: uppercase">Utilisateur</code></span>
                    </div>
                </div>
            </div>
            <div class="col-lg-4">
                <div class="page-header-breadcrumb">
                    <ul class="breadcrumb-title">
                        <li class="breadcrumb-item">
                            <a href="/">
                                <i class="icofont icofont-home"></i>
                            </a>
                        </li>
                        <li class="breadcrumb-item">
                            <a href="#">Afficher Un Utilisateur </a>
                        </li>
                    </ul>
                </div>
            </div>
        </div>
    </div>
    <div class="page-body">
        <div class="row">
            <div class="col-sm-12">
                <!-- Basic Form Inputs card start -->
                <div class="card">
                    <div class="card-block">
                        <h4 class="sub-title">Informations</h4>
                        <form method="post" action="{{route('user.store')}}">
                            @csrf
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Nom</label>
                                <div class="col-sm-10">
                                    <p>{{$user->name}}
                                        @if($user->hasrole('admin'))<span class="badge badge-success">admin</span>@endif
                                        @if($user->hasrole('responsable'))<span class="badge badge-info">responsable</span>@endif
                                    </p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Email</label>
                                <div class="col-sm-10">
                                    <p>{{$user->email}}</p>
                                </div>
                            </div>
{{--                            <div class="form-group row">--}}
{{--                                <label class="col-sm-2 col-form-label">Password</label>--}}
{{--                                <div class="col-sm-10">--}}
{{--                                    <p>{{$user->password}}</p>--}}
{{--                                </div>--}}
{{--                            </div>--}}
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label">Matricule</label>
                                <div class="col-sm-10">
                                    <p>{{$user->matricule}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label"> Structure</label>
                                <div class="col-sm-10">
                                    <p>{{$user->structure->type->name}}|{{$user->structure->nom}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label"> Demande Versement(s)</label>
                                <div class="col-sm-10">
                                    <p>{{$user->versements->count()}}</p>
                                </div>
                            </div>
                            <div class="form-group row">
                                <label class="col-sm-2 col-form-label"> Demande Consultation(s)</label>
                                <div class="col-sm-10">
                                    <p>{{$user->consultations->count()}}</p>
                                </div>
                            </div>


                        </form>
                    </div>
                </div>
                <!-- Basic Form Inputs card end -->
            </div>
        </div>

    </div>
@endsection
@section('scripts')
    <script type="text/javascript" src="{{asset('bower_components/select2/js/select2.full.min.js')}}"></script>
    {{--    <script type="text/javascript" src="{{asset('assets/pages/advance-elements/select2-custom.js')}}"></script>--}}
    <script>

        $(document).ready(function() {
            $('.js-example-theme-single').select2();
            $(document).on('change','#options',function () {
                $.ajax({
                    url: '{{route('ajax.structurestype')}}'+'/'+ $('#options').val(),
                    method: "GET",
                    success: function(response) {
                        // $('.select2-voitures').select2().destroy();
                        $(".structures").html(response);
                        $('.js-example-theme-single').select2();
                    }
                });
            });
        });
    </script>
@endsection